"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Listener = void 0;
const vscode = require("vscode");
const repository_1 = require("./repository");
function Listener(respository) {
    vscode.workspace.onDidSaveTextDocument((document) => {
        let bpmnFile = respository.getBPMNFileByTmp(document.uri);
        if (bpmnFile) {
            // Update bpmn file
            let newBPMNContent = bpmnFile.serializeWithNewCode(document.getText());
            if (newBPMNContent) {
                repository_1.saveFile(bpmnFile.uri, newBPMNContent);
            }
            else {
                // TODO : save diagram first then rather then msg
                vscode.window.showErrorMessage('Could not save code. Does the element exist? Did you save the bpmn diagram first?');
            }
        }
    });
    vscode.workspace.onDidChangeTextDocument((document) => {
        let bpmnFile = respository.getBPMNFileByTmp(document.document.uri);
        if (bpmnFile) {
            bpmnFile.unsaved = document.document.isDirty;
            respository.updateBPMNFile(bpmnFile);
        }
    });
}
exports.Listener = Listener;
//# sourceMappingURL=listener.js.map