'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.BpmnModelerBuilder = void 0;
class BpmnModelerBuilder {
    constructor(contents, viewContent, resources) {
        this.contents = contents;
        this.viewContent = viewContent;
        this.resources = resources;
    }
    removeNewLines(contents) {
        return contents.replace(/(\r\n|\n|\r)/gm, ' ');
    }
    buildModelerView() {
        let buff = new Buffer(this.contents);
        let base64data = buff.toString('base64');
        let view = this.viewContent;
        view = view.replace("${this.resources.modelerDistro}", this.resources.modelerDistro);
        view = view.replace("${this.resources.diagramStyles}", this.resources.diagramStyles);
        view = view.replace("${this.resources.bpmnFont}", this.resources.bpmnFont);
        view = view.replace("${this.resources.modelerStyles}", this.resources.modelerStyles);
        view = view.replace("${this.resources.codiconsFont}", this.resources.codiconsFont);
        view = view.replace("${this.resources.resourceUri}", this.resources.resourceUri);
        view = view.replace("${this.contents}", base64data);
        return view;
    }
}
exports.BpmnModelerBuilder = BpmnModelerBuilder;
//# sourceMappingURL=bpmnModelerBuilder.js.map